local Hatmaker = ...

-- Register prefab nodes (currently only one core model)
Hatmaker:registerAssetId("models/hatmaker.fbx/Prefab/hatmakerPart", "HATMAKER_WORKPLACE_PREFAB")

Hatmaker:register({
--Dclare que l'objet que l'on cre appartient  la class BUILDING
	DataType = "BUILDING",
--Dclare la classe de l'objet que l'on cre
	Id = "HATMAKER_WORKPLACE",
	Name = "HATMAKER_WORKPLACE_NAME",
	Description = "HATMAKER_WORKPLACE_DESC",
--Renseigne le champ Building Type. cela va permettre de classer l'objet dans les menus
	BuildingType = "GENERAL",
--renseigne le champ BuildingPartList de l'objet que l'on cre un peu plus loin	
	BuildingPartSetList = {
		{
			Name = "HATMAKER_WORKPLACE_PARTSETLIST_NAME",
	                BuildingPartList = { 
                            "HATMAKER_WORKPLACE_PART"
                        }
                }
        }
--Renseigne le champ Nombre de villageois requis pour la construction. Ici inactiv pour le test
	--VillagerRequired = { Status = "NEWCOMER", Quantity = 9 }
})

-- Register the hatmaker workplace part
Hatmaker:register({
	DataType = "BUILDING_PART",
	Id = "HATMAKER_WORKPLACE_PART",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "HATMAKER_WORKPLACE_PREFAB"
	},
--Ca c'est pour dclarer le visuel de construction si il y en a un !
	ConstructionVisual = "HATMAKER_WORKPLACE_PREFAB",
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 }
		}
	},
	AssetBuildingFunction = "HATMAKER_FUNCTION"
})

Hatmaker:register({
		DataType = "BUILDING_FUNCTION_MARKET",
                Id = "HATMAKER_FUNCTION",
                TypeList = { "GOODS" },
                IsOverrideCapacity = true,
                CapacityPerSlot = 50,
		WorkerCapacity = 1,                
                RelatedJob = { Job = "HATMAKER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "WOOLEN_CLOTH", Quantity = 50 }
                },
                ResourceListNeeded = {
                	{ Resource = "WOOLEN_CLOTH", Quantity = 1 }
                },
                ResourceProduced = {
			{ Resource = "HAT", Quantity = 1 }
                }
})

-- Register grounding components

Hatmaker:registerPrefabComponent("models/hatmaker.fbx/Prefab/hatmakerPart/step_2_A", {
	DataType = "COMP_GROUNDED"
})
Hatmaker:registerPrefabComponent("models/hatmaker.fbx/Prefab/hatmakerPart/step_2_B", {
	DataType = "COMP_GROUNDED"
})
Hatmaker:registerPrefabComponent("models/hatmaker.fbx/Prefab/hatmakerPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 4, 4 }
})
